// VisualClassBuilderDoc.cpp : implementation of the CVisualClassBuilderDoc class
//

#include "stdafx.h"
#include "VisualClassBuilder.h"

#include "VisualClassBuilderDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVisualClassBuilderDoc

IMPLEMENT_DYNCREATE(CVisualClassBuilderDoc, CDocument)

BEGIN_MESSAGE_MAP(CVisualClassBuilderDoc, CDocument)
	//{{AFX_MSG_MAP(CVisualClassBuilderDoc)
	ON_COMMAND(ID_INSERT_CLASS, OnInsertClass)
	ON_COMMAND(ID_BUILD_GENERATE_FILES, OnBuildGenerateFiles)
	ON_COMMAND(ID_INSERT_STRUCT, OnInsertStruct)
	ON_COMMAND(ID_BUILD_CLEAR_OUTPUT, OnBuildClearOutput)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVisualClassBuilderDoc construction/destruction

CVisualClassBuilderDoc::CVisualClassBuilderDoc()
{
	// TODO: add one-time construction code here

}

CVisualClassBuilderDoc::~CVisualClassBuilderDoc()
{
}

BOOL CVisualClassBuilderDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// Destroy object list
	m_VCBObjectManager.ClearVBCObjectList();

	// Set document modified flag
	SetModifiedFlag(TRUE);

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CVisualClassBuilderDoc serialization

void CVisualClassBuilderDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// Save project file
		m_VCBObjectManager.SaveToArchive(ar);
	}
	else
	{
		// Load project file
		m_VCBObjectManager.LoadFromArchive(ar);
	}

	// Refresh window
	UpdateAllViews(NULL);
}

/////////////////////////////////////////////////////////////////////////////
// CVisualClassBuilderDoc diagnostics

#ifdef _DEBUG
void CVisualClassBuilderDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CVisualClassBuilderDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CVisualClassBuilderDoc commands

void CVisualClassBuilderDoc::OnInsertClass() 
{
	// Add new CVCBClass object
	RECT rect = {10, 10, 160, 215};
	CVCBClass* pNewVCBClass = new CVCBClass(rect);
	CString strClassName, strHeaderFile, strImplementationFile;
	strClassName.Format(_T("CMyClass%d"), m_VCBObjectManager.GetLastObjectID()+1);
	strHeaderFile.Format(_T("MyClass%d.h"), m_VCBObjectManager.GetLastObjectID()+1);
	strImplementationFile.Format(_T("MyClass%d.cpp"), m_VCBObjectManager.GetLastObjectID()+1);
	pNewVCBClass->SetVCBClassName((LPTSTR)((LPCTSTR)strClassName));
	pNewVCBClass->SetVCBClassHeaderFile((LPTSTR)((LPCTSTR)strHeaderFile));
	pNewVCBClass->SetVCBClassImplementationFile((LPTSTR)((LPCTSTR)strImplementationFile));
	m_VCBObjectManager.AddVCBObject(pNewVCBClass);

	// Set document modified flag
	SetModifiedFlag(TRUE);

	// Refresh window
	UpdateAllViews(NULL);
}

void CVisualClassBuilderDoc::OnInsertStruct() 
{
	// Add new CVCBStruct object
	RECT rect = {10, 10, 160, 120};
	CVCBStruct* pNewVCBStruct = new CVCBStruct(rect);
	CString strStructName;
	strStructName.Format(_T("MY_STRUCT_%d"), m_VCBObjectManager.GetLastObjectID()+1);
	pNewVCBStruct->SetVCBStructName((LPTSTR)((LPCTSTR)strStructName));
	m_VCBObjectManager.AddVCBObject(pNewVCBStruct);

	// Set document modified flag
	SetModifiedFlag(TRUE);

	// Refresh window
	UpdateAllViews(NULL);
}

void CVisualClassBuilderDoc::OnBuildClearOutput() 
{
	// Clear output directory
	_TCHAR lpszPathName[_MAX_PATH];
	CString strFile;
	WIN32_FIND_DATA win32FindData;
	memset(&win32FindData, 0, sizeof(WIN32_FIND_DATA));
	HANDLE hFindFile = FindFirstFile(_T("output\\*"), &win32FindData);
	while (FindNextFile(hFindFile, &win32FindData))
	{
		// Delete file
		GetCurrentDirectory(_MAX_PATH, lpszPathName);
		strFile.Format(_T("%s\\output\\%s"), lpszPathName, win32FindData.cFileName);
		DeleteFile(strFile);
	}
	FindClose(hFindFile);	
}

void CVisualClassBuilderDoc::OnBuildGenerateFiles() 
{
	// Clear output directory
	OnBuildClearOutput();

	// Check for valid object list
	if (m_VCBObjectManager.GetVCBObjectNumber() > 0)
	{
		// Generate output files
		m_VCBObjectManager.GenerateOutputFiles();

		AfxMessageBox(_T("You have successfully generated output files!"), MB_OK);
	}
	else
		AfxMessageBox(_T("You have no classes/structs to generate output files..."), MB_OK);
}
