// VCBObject.h: interface for the CVCBObject class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(VCBOBJECT_H)
#define VCBOBJECT_H

#include "VCBIncludes.h"


class CVCBObject  
{
public:
	CVCBObject();
	virtual ~CVCBObject();

public:
	// CVCBObject class interface
	virtual VCBOBJ_TYPE GetVCBObjectType();
	virtual void DrawVCBObject(HDC hDC) = 0;
	virtual void SelectVCBObject(POINT pt) = 0;
	virtual BOOL IsVCBObjectSelected();
	virtual void ShowVCBObjectShadow(BOOL bShadow);
	virtual DWORD GetVCBObjectID();
	virtual void SetVCBObjectID(DWORD id);
	virtual void MoveObject(int offsetX, int offsetY) = 0;
	virtual void GenerateOutputFile() = 0;
	virtual void SaveObject(CArchive& ar) = 0;

protected:
	// CVCBObject class members
	VCBOBJ_TYPE m_nObjectType;
	DWORD m_dwObjectID;
	HDC m_hMemDC;
	HBITMAP m_hMemBitmap;
	HBITMAP m_hOldMemBitmap;
	HDC m_hShadowDC;
	HBITMAP m_hShadowBitmap;
	HBITMAP m_hOldShadowBitmap;
	HDC m_hBackgroundDC;
	HBITMAP m_hBackgroundBitmap;
	HBITMAP m_hOldBackgroundBitmap;
	BOOL m_bIsSelected;
	BOOL m_bShowShadow;

};

#endif // !defined(VCBOBJECT_H)
