// VCBStruct.h: interface for the CVCBStruct class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(VCBSTRUCT_H)
#define VCBSTRUCT_H

#include "VCBObject.h"


class CVCBStruct : public CVCBObject  
{
public:
	CVCBStruct(RECT rect);
	virtual ~CVCBStruct();

public:
	// CVCBStruct class interface
	void DrawVCBObject(HDC hDC);
	void SelectVCBObject(POINT pt);
	RECT GetVCBObjectRect();
	void MoveObject(int offsetX, int offsetY);
	void GenerateOutputFile();
	void GenerateHeaderFile();
	void GenerateImplementationFile() {};
	_TCHAR* GetVCBStructName();
	void SetVCBStructName(_TCHAR* lpszStructName);
	_TCHAR* GetVCBStructHeaderFile();
	void SetVCBStructHeaderFile(_TCHAR* lpszStructHeaderFile);
	_TCHAR* GetVCBStructAuthor();
	void SetVCBStructAuthor(_TCHAR* lpszAuthor);
	_TCHAR* GetVCBStructDescription();
	void SetVCBStructDescription(_TCHAR* lpszDescription);
	int GetVCBStructVariableNumber();
	void SetVCBStructVariableNumber(int number);
	VARIABLE_TYPE* GetVCBStructVariables();
	void SetVCBStructVariables(VARIABLE_TYPE* pVariableList);
	void SaveObject(CArchive& ar);

private:
	// CVCBStruct private methods
	void DrawShadow();
	void DrawBackground();
	void UpdateTransparency(HDC hDC);

private:
	// CVCBStruct class members
	RECT m_rcObjectRect;
	HFONT m_hStructNameFont;
	HFONT m_hAttributesFont;
	_TCHAR m_lpszStructName[256];
	_TCHAR m_lpszStructHeaderFile[1024];
	_TCHAR m_lpszAuthor[256];
	_TCHAR m_lpszDescription[256];
	VARIABLE_TYPE* m_pVariableList;
	int m_iVariableNumber;

};

#endif // !defined(VCBSTRUCT_H)
